﻿using System;
using System.ComponentModel;

namespace WinFormsMVC.Inheritance
{
    public class ConcreteViewFormProvider : TypeDescriptionProvider
    {
        public ConcreteViewFormProvider()
            : base(TypeDescriptor.GetProvider(typeof(ViewForm)))
        {
        }

        public override Type GetReflectionType(Type objectType, object instance)
        {
            if (objectType == typeof(ViewForm))
                return typeof(ConcreteViewForm);

            return base.GetReflectionType(objectType, instance);
        }

        public override object CreateInstance(IServiceProvider provider, Type objectType, Type[] argTypes, object[] args)
        {
            if (objectType == typeof(ViewForm))
                objectType = typeof(ConcreteViewForm);

            return base.CreateInstance(provider, objectType, argTypes, args);
        }
    }
}
