﻿using System;
using System.ComponentModel;

namespace WinFormsMVC.Inheritance
{
    public class ConcreteViewUserControlProvider : TypeDescriptionProvider
    {
        public ConcreteViewUserControlProvider()
            : base(TypeDescriptor.GetProvider(typeof(ViewUserControl)))
        {
        }

        public override Type GetReflectionType(Type objectType, object instance)
        {
            if (objectType == typeof(ViewUserControl))
                return typeof(ConcreteViewUserControl);

            return base.GetReflectionType(objectType, instance);
        }

        public override object CreateInstance(IServiceProvider provider, Type objectType, Type[] argTypes, object[] args)
        {
            if (objectType == typeof(ViewUserControl))
                objectType = typeof(ConcreteViewUserControl);

            return base.CreateInstance(provider, objectType, argTypes, args);
        }
    }
}
